﻿Option Explicit On

Module modHalbr

    Public strEHL As String, strEHF As String, strEHS As String
    Public strProjekt As String, strPosition As String
    Public strDateiName As String

    Public Bx As Single, By As Single
    Public z As Single, Es As Single
    Public X1(4) As Single, Y1(4) As Single, x As Single, y As Single, y0 As Single
    Public qz As Single, qh As Single
    Public mue As Single, EMod As Single, GMod As Single, t As Single
    Public nTx As Integer, nTy As Integer
    Public lx As Single, ly As Single
    Public maxvz As Single, maxSig As Single
    Public blnSymmetrie As Boolean
    Public blnGrundlinien As Boolean, blnLastfläche As Boolean
    Public blnAllesSpeichern As Boolean
    Public x_A() As Single, vz_A(,) As Single
    Public sig_A(,) As Single
    Public vz_Aver(,) As Single, vz_Ahor(,) As Single
    Public sig_Aver(,) As Single, sig_Ahor(,) As Single
    Public sigx_Aver(,) As Single, sigx_Ahor(,) As Single
    Public sigy_Aver(,) As Single
    Public sigx_A(,) As Single
    Public sigy_A(,) As Single
    Public vx_A(,) As Single, vx_Aver(,) As Single
    Public vx_Ahor(,) As Single
    Public maxSigx As Single, maxSigy As Single, vx As Single
    Public maxvx As Single, maxvy As Single
    Public x0 As Single
    Public verx As Single, very As Single

    Public strZahl(5) As String
    Public strLinie(5) As String
    Public blnBerechnung As Boolean

    Public Const strPgmName = "Halbraum"
    Public Const strVersion = "5.0"

    Public Sub Dimensionierung()
        'Arrays dimensionieren
        ReDim x_A(nTx), vz_A(nTx, nTy)
        ReDim sig_A(nTx, nTy)
        ReDim vz_Aver(nTx, nTy), vz_Ahor(nTx, nTy)
        ReDim sig_Aver(nTx, nTy), sig_Ahor(nTx, nTy)
        ReDim sigx_Aver(nTx, nTy), sigx_Ahor(nTx, nTy)
        ReDim sigy_Aver(nTx, nTy)
        ReDim sigx_A(nTx, nTy)
        ReDim sigy_A(nTx, nTy)
        ReDim vx_A(nTx, nTy), vx_Aver(nTx, nTy)
        ReDim vx_Ahor(nTx, nTy)
    End Sub

    Public Sub BodenSpgVerf_qz()
        'Verformungen und Bodenspannungen bei vertikalen Flächenlasten auf GOK
        'Bx = Länge der Flächenlast
        'By = Breite der Flächenlast
        'qz = Lastintensität
        'z = Auswertungstiefe
        'lx = Auswertungslänge
        'ly = Auswertungsbreite
        'x0 = Abstand der Lastmitte in x-Richtung
        'y0 = Abstand der Lastmitte in y-Richtung

        Dim fak As Single, sum As Single
        Dim r As Single, Zw As Single, vz As Single
        Dim ix As Integer, iy As Integer, i As Integer
        Dim FakSig As Single, sig As Single
        Dim sigx As Single, sigy As Single
        Dim Zw1 As Single
        Dim xq As Single, yq As Single

        strLinie(1) = "Verformungen vz"
        strLinie(2) = "Verformungen vx"
        strLinie(3) = "Bodenspannungen sigz"
        strLinie(4) = "Bodenspannungen sigx"
        strLinie(5) = "Bodenspannungen sigy"

        strEHS = strEHF + "/" + strEHL + "²"

        EMod = Es * (1 + mue) * (1 - 2 * mue) / (1 - mue)
        GMod = EMod / 2 / (1 + mue)                   'nach GB TB 1, Seite 261
        fak = -qz / 1000 / 4 / Math.PI / GMod              'qz von kN/m² in N/mm²
        FakSig = -qz / 2 / Math.PI

        maxvz = 0 : maxvx = 0
        maxSig = 0 : maxSigx = 0

        For ix = 0 To nTx Step 1
            x = -lx + ix * lx / 20
            x_A(ix) = x

            X1(1) = -Bx / 2 : X1(2) = -Bx / 2
            X1(3) = Bx / 2 : X1(4) = Bx / 2
            Y1(1) = -By / 2 : Y1(2) = By / 2
            Y1(3) = By / 2 : Y1(4) = -By / 2

            For iy = 0 To nTy Step 1
                y = -ly + iy * ly / 20

                'Verformungen vz
                sum = 0
                For i = 1 To 4
                    xq = x0 + x + X1(i) : yq = y0 + y + Y1(i)
                    r = (xq ^ 2 + yq ^ 2 + z ^ 2) ^ 0.5
                    Zw = 2 * (1 - mue) * (xq * Math.Atan(yq / r) + yq * Math.Atan(xq / r))
                    Zw = Zw - (1 - 2 * mue) * z * Math.Atan(xq * yq / z / r)
                    sum = sum + Zw * (-1) ^ i
                Next i
                vz = fak * sum * 1000           'fak dim.los, sum von m in mm
                vz_Aver(ix, iy) = -vz
                vz_A(ix, iy) = -vz
                If Math.Abs(vz) > Math.Abs(maxvz) Then maxvz = vz

                'Verformungen vx
                sum = 0
                For i = 1 To 4
                    xq = x0 + x + X1(i) : yq = y0 + y + Y1(i)
                    r = (xq ^ 2 + yq ^ 2 + z ^ 2) ^ 0.5
                    Zw1 = z * Math.Atan(yq / r)
                    Zw = yq * Math.Log(z + r) + z * Math.Atan(yq / r)
                    If Math.Abs(xq) > 0.000001 Then
                        Zw = Zw + xq * Math.Atan(yq / xq)
                        Zw = Zw1 + (1 - 2 * mue) * (Zw - Math.Atan(yq * z / xq / r))
                    Else
                        Zw = Zw + xq * Math.PI / 2
                        Zw = Zw1 + (1 - 2 * mue) * (Zw - Math.PI / 2)
                    End If
                    sum = sum + Zw * (-1) ^ i
                Next i
                vx = -fak * sum * 1000           'fak dim.los, sum von m in mm
                vx_Aver(ix, iy) = -vx
                vx_A(ix, iy) = -vx
                If Math.Abs(vx) > Math.Abs(maxvx) Then maxvx = vx

                'Spannungen sigmaz
                sum = 0
                For i = 1 To 4
                    xq = x0 + x + X1(i) : yq = y0 + y + Y1(i)
                    r = (xq ^ 2 + yq ^ 2 + z ^ 2) ^ 0.5
                    Zw = (1 / (xq ^ 2 + z ^ 2) + 1 / (yq ^ 2 + z ^ 2)) * _
                         xq * yq * z / r
                    Zw = Zw + Math.Atan(yq * xq / z / r)
                    sum = sum + Zw * (-1) ^ i
                Next i
                sig = FakSig * sum           'kN/m²
                sig_Aver(ix, iy) = -sig
                sig_A(ix, iy) = -sig
                If Math.Abs(sig) > Math.Abs(maxSig) Then maxSig = sig

                'Spannungen sigmax
                sum = 0
                For i = 1 To 4
                    xq = x0 + x + X1(i) : yq = y0 + y + Y1(i)
                    r = (xq ^ 2 + yq ^ 2 + z ^ 2) ^ 0.5
                    Zw1 = xq * yq * z
                    Zw = Zw1 / (xq ^ 2 + z ^ 2) / r
                    Zw = Zw - 2 * mue * Math.Atan(Zw1 / z ^ 2 / r)
                    If Math.Abs(x0 + x + X1(i)) > 0.000001 Then
                        Zw = Zw - (1 - 2 * mue) * Math.Atan(yq / xq)
                        Zw = Zw + (1 - 2 * mue) * Math.Atan(yq * z / xq / r)
                    End If
                    sum = sum + Zw * (-1) ^ i
                Next i
                sigx = FakSig * sum           'kN/m²
                sigx_Aver(ix, iy) = sigx
                sigx_A(ix, iy) = sigx
                If Math.Abs(sigx) > Math.Abs(maxSigx) Then maxSigx = sigx

                'Spannungen sigmay
                sum = 0
                For i = 1 To 4
                    xq = x0 + x + X1(i) : yq = y0 + y + Y1(i)
                    r = (xq ^ 2 + yq ^ 2 + z ^ 2) ^ 0.5
                    Zw1 = xq * yq * z
                    Zw = Zw1 / (yq ^ 2 + z ^ 2) / r
                    Zw = Zw - 2 * mue * Math.Atan(Zw1 / z ^ 2 / r)
                    If Math.Abs(y0 + y + Y1(i)) > 0.000001 Then
                        Zw = Zw - (1 - 2 * mue) * Math.Atan(xq / yq)
                        Zw = Zw + (1 - 2 * mue) * Math.Atan(xq * z / yq / r)
                    End If
                    sum = sum + Zw * (-1) ^ i
                Next i
                sigy = FakSig * sum           'kN/m²
                sigy_Aver(ix, iy) = sigy
                sigy_A(ix, iy) = sigy
                If Math.Abs(sigy) > Math.Abs(maxSigy) Then maxSigy = sigy

            Next iy
        Next ix

        strZahl(1) = maxvz.ToString("##0.00 mm")
        strZahl(2) = maxvx.ToString("##0.00 mm")
        strZahl(3) = maxSig.ToString("##0.00 ") + strEHS
        strZahl(4) = maxSigx.ToString("##0.00 ") + strEHS
        strZahl(5) = maxSigy.ToString("##0.00 ") + strEHS

    End Sub   'BodenSpgVerf_qz

    Public Sub BodenSpgVerf_qx()
        'Verformungen und Bodenspannungen bei horizontalen Flächenlasten auf GOK
        'Bx = Länge der Flächenlast
        'By = Breite der Flächenlast
        'qh = Lastintensität
        'z = Auswertungstiefe
        'y0 = Abstand in y-Richtung
        'lx = Auswertungslänge
        'ly = Auswertungsbreite
        'x0 = Abstand in x-Richtung
        'mögliche Erweiterung: sigx aus qh

        Dim fak As Single, sum As Single
        Dim r As Single, Zw As Single, vz As Single
        Dim ix As Integer, iy As Integer, i As Integer
        Dim FakSig As Single, sig As Single
        Dim Nenn As Single
        Dim xq As Single, yq As Single

        'nTx = 40: nTy = 40        'Eingabe ganze Fläche (bei qh keine Symmetrie)

        EMod = Es * (1 + mue) * (1 - 2 * mue) / (1 - mue)
        GMod = EMod / 2 / (1 + mue)                   'nach GB TB 1, Seite 261
        fak = -qh / 1000 / 4 / Math.PI / GMod           'qh von kN/m² in N/mm²
        FakSig = -qh / 2 / Math.PI

        maxvz = 0
        maxSig = 0

        For ix = 0 To nTx Step 1
            x = -lx + ix * lx / 20
            x_A(ix) = x

            X1(1) = -Bx / 2 : X1(2) = -Bx / 2
            X1(3) = Bx / 2 : X1(4) = Bx / 2
            Y1(1) = -By / 2 : Y1(2) = By / 2
            Y1(3) = By / 2 : Y1(4) = -By / 2

            For iy = 0 To nTy Step 1
                y = -ly + iy * ly / 20

                'Verformungen vz
                sum = 0
                For i = 1 To 4
                    xq = x0 + x + X1(i) : yq = y0 + y + Y1(i)
                    r = (xq ^ 2 + yq ^ 2 + z ^ 2) ^ 0.5
                    Nenn = xq
                    If Math.Abs(Nenn) < 0.000001 Then
                        Nenn = 0.000001
                    End If
                    Zw = z * Math.Atan(yq / r)
                    Zw = Zw - (1 - 2 * mue) * (yq * Math.Log(z + r) + _
                         z * Math.Atan(yq / r) + _
                         xq * (Math.Atan(yq / Nenn) - Math.Atan(yq * z / (Nenn * r))))
                    sum = sum + Zw * (-1) ^ i
                Next i

                vz = fak * sum * 1000           'fak dim.los, sum von m in mm
                vz_Ahor(ix, iy) = -vz
                vz_A(ix, iy) = vz_Aver(ix, iy) + vz_Ahor(ix, iy)
                If Math.Abs(vz_A(ix, iy)) > Math.Abs(maxvz) Then maxvz = vz_A(ix, iy)

                'Spannungen sigmaz
                sum = 0
                For i = 1 To 4
                    xq = x0 + x + X1(i) : yq = y0 + y + Y1(i)
                    r = (xq ^ 2 + yq ^ 2 + z ^ 2) ^ 0.5
                    Zw = yq * z ^ 2 / ((xq ^ 2 + z ^ 2) * r)
                    sum = sum + Zw * (-1) ^ i
                Next i

                sig = FakSig * sum           'kN/m²
                sig_Ahor(ix, iy) = -sig
                sig_A(ix, iy) = sig_Aver(ix, iy) + sig_Ahor(ix, iy)
                If Math.Abs(sig_A(ix, iy)) > Math.Abs(maxSig) Then maxSig = sig_A(ix, iy)

            Next iy
        Next ix

        strZahl(1) = maxvz.ToString("##0.00 mm")
        strZahl(2) = maxSig.ToString("##0.00 kN/m²")

    End Sub   'BodenSpgVerf_qx

    Public Sub Vorbelegung()
        'Vorbelegungen

        strEHL = "m"
        strEHF = "kN"
        strProjekt = "Beispiel"
        strPosition = "1"
        'strDateiName = App.Path + "\" + "..."

        'Streifenfundament
        Bx = 2                  'm
        By = 0.3                'm
        z = 1.3                 'm
        Es = 15                 'MN/m²
        qz = 100                'kN/m²
        qh = 0                  'kN/m²
        lx = 4
        ly = 4
        y0 = 0
        x0 = 0

        'Erzhalde neben einem Sammler
        'Bx = 30                 'm
        'By = 20                 'm
        'z = 4.64                'm
        'Es = 40                 'MN/m²
        'qz = 324                'kN/m²
        'qh = 0                  'kN/m²
        'lx = 60
        'ly = 30
        'y0 = 0
        'x0 = -15

        'Radlast des Tandemsystems nach DIN-FB 101
        Bx = 0.4                'm
        By = 0.4                'm
        z = 0.8                 'm
        Es = 40                 'MN/m²
        qz = 750                'kN/m²
        qh = 0                  'kN/m²
        lx = 2
        ly = 2
        y0 = 0
        x0 = 0

        'Berechnung an nTx und nTy Stützpunkten
        If blnSymmetrie Then
            nTx = 20 : nTy = 20           'Eingabe halbe Fläche - Symmetrie
        Else
            nTx = 40 : nTy = 40           'Eingabe ganze Fläche
        End If

        mue = 0.3

        verx = 1 : very = 0.6
        blnSymmetrie = False
        blnGrundlinien = False
        blnLastfläche = True
        blnAllesSpeichern = True

    End Sub   'Vorbelegung

End Module
